<?php


namespace OrganizationsManagement\Controller;

use OrganizationsManagement\Traits\TResponse;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use OrganizationsManagement\Util\Utilities;
use OrganizationsManagement\Util\InstanceProvider;
use \OrganizationsManagement\Service\Organization as OrganizationService;

class Organization
{

    use TResponse;

    private $organizationService;

    public function __construct(OrganizationService $organizationService){
        $this->organizationService = $organizationService;
    }

    /**
     * @param DTO\Request $request
     * @param DTO\Response $response
     * @throws Exception
     */
    public function findSaasOrganizations(DTO\Request $request, DTO\Response $response){
        try{
            $data = $this->organizationService->findSaasOrganizations();
            $this->sendResponse($data, 200);
        }catch(Exception $ex){
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
